/*
 * main.c
 *
 *  Created on: 27-12-2013
 *      Author: Mirosaw Karad
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#define LED1 (1<<PB6)
#define LED2 (1<<PB7)
#define LED3 (1<<PD5)
#define LED4 (1<<PD6)
#define LED5 (1<<PD7)

#define LED1_ON PORTB &= ~LED1
#define LED1_OFF PORTB |= LED1
#define LED1_TOG PORTB ^= LED1
#define LED2_ON PORTB &= ~LED2
#define LED2_OFF PORTB |= LED2
#define LED2_TOG PORTB ^= LED2

#define LED3_ON PORTD &= ~LED3
#define LED3_OFF PORTD |= LED3
#define LED3_TOG PORTD ^= LED3
#define LED4_ON PORTD &= ~LED4
#define LED4_OFF PORTD |= LED4
#define LED4_TOG PORTD ^= LED4
#define LED5_ON PORTD &= ~LED5
#define LED5_OFF PORTD |= LED5
#define LED5_TOG PORTD ^= LED5



// deklaracje funkcji
void leds_off(void);



// gwna funkcja programu
int main( void ) {

	DDRB |= LED1|LED2;
	DDRD |= LED3|LED4|LED5;

	leds_off();

	PCICR |= (1<<PCIE2);  // zezwolenie na przerwanie PCIE2
	PCMSK2 |= (1<<PCINT18); // przerwanie PCINT na pinie PD2

	DDRC |= (1<<PC5); // pin PC5 = wyjcie

	EICRA |= (1<<ISC01)|(1<<ISC00); // INT0 - wyzwalane zboczem narastajcym
	EIMSK |= (1<<INT0);  // zezwolenie na przerwanie INT0



	sei();
	while(1) {
		PORTC ^= (1<<PC5);
		_delay_ms(1000);

	}
}


// procedury obsugi przerwa
ISR( INT0_vect ) {
	LED2_TOG;
}


ISR( PCINT2_vect ) {
	if( !(PIND & (1<<PD2) ) ) LED1_TOG;
}

// ------- definicje funkcji
void leds_off(void) {
	LED1_OFF; LED2_OFF; LED3_OFF; LED4_OFF; LED5_OFF;
}

